import * as React from 'react';
import * as PropTypes from 'prop-types';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
// import PauseIcon from 'grommet/components/icons/base/PauseFill';
// import ContinueIcon from 'grommet/components/icons/base/PlayFill';
// import * as allActions from '../../actions';
// import { now, DatePicker } from '../../state/datePicker';
// import { createPDF, createTextElement, createChartElement } from '../common/PdfCreator';
import WidgetGrid from '../Widget/WidgetGrid';
// import { Dashboard } from '../../state/dashboard';
// import { WIDGET_TYPE, createTextWidget } from '../../state/widget';
// import { SeSearch } from '../../state/seSearch';
import WidgetPlaceholder from './WidgetPlaceholder';
// import HerculesPage from '../common/HerculesPage';
// import { findPlotlyCharts } from '../common/charts/PlotlyPlot';
// import { limitConstant } from '../search/overSearchLimitPopup/limitConstant';
// import { createSearchFromWidget } from '../../common/searchGenerator';
// import { generateSearchName } from '../common/Utils';
import { Dashboard } from '../../types'
import { DashboardModel } from './DashboardModel';

const LABEL_ADD_TEXT_BOX = 'Add Text Box';
const LABEL_REFRESH = 'Refresh';
const LABEL_RENAME = 'Rename';
const LABEL_DELETE = 'Delete';
const LABEL_CREATE_SEARCH = 'Create search';

interface DashboardProps {
  actions: any
  dashboard: Dashboard
}

interface DashboardState {

}

class DashboardPage extends React.Component<DashboardProps, DashboardState> {
  public static get propTypes() {
    return ({
      activeSearch: PropTypes.object.isRequired,
      actions: PropTypes.object.isRequired,
      dashboard: PropTypes.object.isRequired,
      user: PropTypes.object.isRequired,
      searches: PropTypes.object.isRequired
    })
  }

  constructor(props: DashboardProps) {
    super(props);
  }

  exportToPDF = () => {
    const { dashboard } = this.props;
    const dashboardObj = new DashboardModel(dashboard);
    /*
    const chartElements = findPlotlyCharts();

    let chartCounter = 0;
    const pdfElements = dashboardObj.getWidgets().map(widget => {
      switch (widget.getType()) {
        case WIDGET_TYPE.CHART:
          return createChartElement(widget, chartElements[chartCounter++]);
        case WIDGET_TYPE.TEXTBOX:
          return createTextElement(widget.getName(), widget.getContent().getText());
        default:
          return undefined;
      }
    });
    const documentTitle = 'Dashboard';
    return createPDF(documentTitle, pdfElements, documentTitle);
    */
  }
  /*
  addTextBoxWidget() {
    const { actions, dashboard } = this.props;
    const dashboardObj = new Dashboard(dashboard);
    if (dashboardObj.canAddWidget()) {
      actions.addWidgetToDashboard(dashboardObj, createTextWidget(dashboardObj));
    }
  }
  */
  /*
  getHeaderOptions = () => {
    const options = [{
      label: LABEL_ADD_TEXT_BOX,
      onClick: this.addTextBoxWidget
    }];

    const { actions, dashboard } = this.props;
    const dashboardObj = new Dashboard(dashboard);

    if (dashboardObj.hasRefresh()) {
      options.unshift({
        label: LABEL_REFRESH,
        disabled: !dashboardObj.canRefresh(),
        onClick: () => {
          const time = now();
          const widgets = dashboardObj.getRefreshableWidgets(true);
          const updatedWidgets = widgets.map(widget => widget.refreshDatePicker(time));
          actions.refreshWidgets(updatedWidgets, true, () =>
            actions.saveRefreshedDashboard(dashboardObj, time)
          );
        }
      });

      const refreshTime = dashboardObj.getContent().getRefreshTime();
      if (refreshTime && dashboardObj.hasRefresh()) {
        const label = `Refreshed on ${DatePicker.formatTime(refreshTime)}`;
        options.unshift({ label });
      }
    }
    return options;
  }
  */
  /*
   getWidgetGridConfig = () => {
     const { actions, dashboard } = this.props;
     const dashboardObj = new Dashboard(dashboard);
 
     const tooltipActions = {
       toggleRename: actions.toggleRenameWidget,
       rename: actions.renameWidget,
       delete: actions.deleteWidget
     };
 
     const exceedsSessionSearchLimit = () => {
       const { searches } = this.props;
       const sessionCount = Object
         .values(searches)
         .filter((search) => search.session).length;
       return sessionCount >= limitConstant.sessionSearch;
     };
 
     const createSearch = (widget) => {
       if (!exceedsSessionSearchLimit()) {
         const { searches } = this.props;
         const search = createSearchFromWidget(widget);
         search.name = generateSearchName(searches);
         actions.saveSearch(search, actions.setActiveSearch);
       }
     };
 
     const tooltip = [
       {
         label: LABEL_RENAME,
         action: tooltipActions.toggleRename
       },
       {
         label: LABEL_DELETE,
         action: tooltipActions.delete
       },
       {
         label: LABEL_REFRESH,
         action: (widget) => {
           const time = now();
           actions.refreshWidget(widget.refreshDatePicker(time), true, updatedWidget =>
             actions.saveRefreshedDashboard(dashboardObj, time, updatedWidget)
           );
         },
         hidden: (widget) => !widget.hasRefresh(),
         disabled: (widget) => !widget.canRefresh()
       },
       {
         label: LABEL_CREATE_SEARCH,
         action: (widget) => createSearch(widget),
         hidden: (widget) => exceedsSessionSearchLimit() || !widget.hasCreateSearch(),
         disabled: (widget) => exceedsSessionSearchLimit() || !widget.canCreateSearch()
       }
     ];
 
     const stopRestart = (stop, restart, defaultValue) => (widget) => {
       const search = widget.getSearch();
       if (search) {
         const seSearch = new SeSearch(search.seSearch || {});
         if (seSearch.isStoppable()) {
           return stop(widget, seSearch);
         }
         if (seSearch.isRestartable()) {
           return restart(widget, seSearch);
         }
       }
       return defaultValue;
     };
 
     const buttons = [{
       icon: stopRestart(() => (<PauseIcon/>), () => (<ContinueIcon/>)),
       label: stopRestart(
         (_, seSearch) => `Pause search (getting data in ${seSearch.printActiveRange()} range)`,
         (_, seSearch) => `Continue search (more data in ${seSearch.printActiveRange()} range)`
       ),
       action: stopRestart(
         (widget) => actions.cancelAllRefresh([widget]),
         (widget) => actions.refreshWidget(widget, true)
       ),
       hidden: stopRestart(() => false, () => false, true)
     }];
     return { actions: tooltipActions, tooltip, buttons };
   }
   */
  render() {
    /*
    const { actions, dashboard, user, activeSearch } = this.props;
    const dashboardObj = new Dashboard(dashboard);
    const textBoxPlaceholder = (
      <WidgetPlaceholder label='Add Text Box' onClick={this.addTextBoxWidget}/>
    );

    return (
      <HerculesPage
        headerText='Dashboard'
        headerOptions={this.getHeaderOptions()}
        permitted={user.permissions.SEARCH_EXECUTE}
        activeSearch={activeSearch}
        actions={actions}
        exportToPDF={this.exportToPDF}>
        <WidgetGrid
          placeholder={textBoxPlaceholder}
          config={this.getWidgetGridConfig()}
          dashboard={dashboardObj}
          actions={actions}/>
      </HerculesPage>
    );
    */
    return (
      <React.Fragment></React.Fragment>
    )
  }
}

function mapStateToProps(state) {
  return {
    activeSearch: state.activeSearch,
    dashboard: state.dashboard,
    user: state.loggedInUser,
    searches: state.search.searches
  };
}

function mapDispatchToProps(dispatch) {
  return {
    // actions: bindActionCreators(allActions, dispatch)
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(DashboardPage);
