import * as React from 'react';
import * as PropTypes from 'prop-types';
import { Icon, Typography } from '@material-ui/core'

const WidgetPlaceholder = (props) => {
  const { onClick, label } = props;

  const clickHandler = () => {
    if (onClick) {
      onClick();
    }
  };

  return (
    <div className='widget-placeholder'
      onClick={clickHandler}>
      <Icon fontSize="large">add</Icon>
      <Typography className='label'>{label}</Typography>
    </div>
  );
};

WidgetPlaceholder.propTypes = {
  label: PropTypes.string,
  onClick: PropTypes.func
};

export default WidgetPlaceholder;
