import * as React from 'react';
import ActionButton from '../../components/Button/ActionButton';

const ActionColumnCellRenderer = ({ data, actions = [] }) => (
  <div className='action-cell-buttons'>
    {actions.map(action =>
      <ActionButton id={action.id}
        key={action.id}
        icon={action.getIcon(data)}
        onClick={() => action.onClick(data)}
        title={action.title}
        small={true} />
    )}
  </div>
);

export default ActionColumnCellRenderer;
