export default class ColumnModel {
  colId: any
  hide: any
  pinned: any
  width: any

  constructor({ colId, hide, pinned, width }) {
    this.colId = colId;
    this.hide = hide || false;
    this.pinned = pinned || false;
    this.width = width || 0;
  }

  isVisible() {
    return !this.hide;
  }

  getPin() {
    return this.pinned;
  }

  getWidth() {
    return this.width;
  }

  getId() {
    return this.colId;
  }

  setVisible(visible) {
    return new ColumnModel({ ...this, hide: !visible });
  }

  setPin(pinned) {
    return new ColumnModel({ ...this, pinned });
  }

  setWidth(width) {
    return new ColumnModel({ ...this, width });
  }

  serialize() {
    return { ...this };
  }
}

export function createColumn(colId, hide, pinned, width) {
  return new ColumnModel({ colId, hide, pinned, width });
}
