import * as React from 'react';
import { generateID } from '../../helpers';

const MENU_ITEM = 'ContextMenuItem';

export default class ContextMenu extends React.Component<any, any> {
  menuElem: any

  componentDidMount() {
    if (this.menuElem) {
      this.menuElem.focus();
    }
  }

  stopEvent(e) {
    e.preventDefault();
    e.stopPropagation();
  }

  render() {
    const { options, onBlur } = this.props;

    if (!options || !options.length) {
      return null;
    }

    return (
      <div className='menu-container' tabIndex={0} onBlur={onBlur}
           ref={(elem) => {
             this.menuElem = elem;
           }}>
        <ul onContextMenu={this.stopEvent}>
          {options.map(({ optionText, action, optionHtml }) =>
            <li id={generateID(MENU_ITEM, optionText)}
                key={generateID(MENU_ITEM, optionText)}
                onMouseUp={(e) => {
                  this.stopEvent(e);
                  if (onBlur) {
                    onBlur();
                  }
                  if (action) {
                    action();
                  }
                }}>
              {optionHtml || <span title={optionText}>{optionText}</span>}
            </li>
          )}
        </ul>
      </div>
    );
  }
}
