export const ORDER = {
  DESC: 'desc',
  ASC: 'asc'
};

export default class HeaderModel {
  columnId: any
  order: any

  constructor({ columnId, order }) {
    this.columnId = columnId;
    this.order = order;
  }

  getColumnId() {
    return this.columnId;
  }

  setOrder(order) {
    return new HeaderModel({ ...this, order });
  }

  getOrder() {
    return this.order === ORDER.DESC ? ORDER.DESC : ORDER.ASC;
  }

  isValid(gridData) {
    return gridData.getHeaders().indexOf(this.columnId) >= 0;
  }

  isEqual(anotherSortInfo) {
    return anotherSortInfo &&
      this.getColumnId() === anotherSortInfo.getColumnId() &&
      this.getOrder() === anotherSortInfo.getOrder();
  }

  serialize() {
    const { columnId, order } = this;
    return { columnId, order };
  }
}

function createSortInfo(columnId, order) {
  return new HeaderModel({ columnId, order });
}

export function createAscendingSortInfo(columnId) {
  return createSortInfo(columnId, ORDER.ASC);
}

export function createDescendingSortInfo(columnId) {
  return createSortInfo(columnId, ORDER.DESC);
}
