import ActionColumnCellRenderer from './ActionColumnCellRenderer';
import HeaderRenderer from './HeaderRenderer';
import DefaultCellRenderer, { createCellRenderer } from './CellRenderer';

const NESTED_ROW_HEIGHT = 250; // TODO should this be set from outside?
const STANDARD_ROW_HEIGHT = 44;
export const COLUMN_WIDTH = 200;
const MIN_COLUMN_WIDTH = 50;

const gridOptions = {
  suppressDragLeaveHidesColumns: true,
  headerHeight: STANDARD_ROW_HEIGHT,
  rowSelection: 'multiple',
  rowDeselection: true,
  enableColResize: true,
  unSortIcon: false,
  enableSorting: true,
  getRowHeight: (params) => (params.node.flower ? NESTED_ROW_HEIGHT : STANDARD_ROW_HEIGHT),
  defaultColDef: {
    lockPinned: true,
    width: COLUMN_WIDTH,
    minWidth: MIN_COLUMN_WIDTH,
    headerComponentFramework: HeaderRenderer,
    cellRendererFramework: createCellRenderer(DefaultCellRenderer)
  },
  columnTypes: {
    actionsColumn: {
      cellRendererFramework: createCellRenderer(ActionColumnCellRenderer),
      checkboxSelection: true,
      headerCheckboxSelection: true,
      sortIcon: false,
      suppressResize: true,
      suppressSorting: true,
      pinned: 'left'
    }
  },
  overlayNoRowsTemplate: '<label class="no-data">No events to show</label>',
  overlayLoadingTemplate: '<span/>'
};

export default gridOptions;