import * as React from 'react'
import { TunnelProvider, TunnelPlaceholder, Tunnel } from 'react-tunnels'
import { Card, CardActionArea, CardActions, CardHeader, CardContent, CardMedia } from '@material-ui/core'

export interface TunnelCardProps extends React.HTMLAttributes<JSX.Element> {
  id: string
}

export default ({ id, children }: TunnelCardProps) => (
  <Card>
    <TunnelProvider>
      <CardHeader>
        <TunnelPlaceholder id={`${id}_header`} />
      </CardHeader>
      <CardActionArea>
        <TunnelPlaceholder id={`${id}_action_area`} />
      </CardActionArea>
      <CardActions>
        <TunnelPlaceholder id={`${id}_actions`} />
      </CardActions>
      <CardContent>
        {children}
      </CardContent>
      <CardMedia>
        <TunnelPlaceholder id={`${id}_media`} />
      </CardMedia>
    </TunnelProvider>
  </Card >
)