import * as React from 'react';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
import useWidget, { WidgetProps, WidgetState } from './useWidget'

// import AlertIcon from 'grommet/components/icons/base/Alert';
// import TableIcon from 'grommet/components/icons/base/Table';
// import ChartIcon from 'grommet/components/icons/base/LineChart';
// import DocumentTextIcon from 'grommet/components/icons/base/DocumentText';
// import EditableInput from './EditableInput';
// import ChartGenerator from './charts/ChartGenerator';
// import Tooltip from './buttons/Tooltip';
// import ActionButton from './buttons/ActionButton';
// import { WIDGET_TYPE } from '../../state/widget';
// import AutosaveText from './AutosaveText';
// import DataTable from './DataTable';

/*
const getFlipperTitle = (widgetType) => {
  switch (widgetType) {
    case WIDGET_TYPE.CHART:
      return 'Chart View';
    case WIDGET_TYPE.TABLE:
      return 'Table View';
    case WIDGET_TYPE.TEXTBOX:
      return 'Text View';
    default:
      return '';
  }
};
*/
/*
const getFlipperIcon = (widgetType) => {
  switch (widgetType) {
    case WIDGET_TYPE.CHART:
      return <ChartIcon/>;
    case WIDGET_TYPE.TABLE:
      return <TableIcon/>;
    case WIDGET_TYPE.TEXTBOX:
      return <DocumentTextIcon/>;
    default:
      return undefined;
  }
};
*/
class Widget extends React.Component<WidgetProps, WidgetState> {
  public static get defaultProps() {
    return ({
      config: {
        buttons: [],
        actions: {},
        tooltip: []
      }
    })
  }

  public static get propTypes() {
    return ({
      frontContent: PropTypes.object.isRequired,
      backContent: PropTypes.object,
      overlay: PropTypes.bool,
      actions: PropTypes.object.isRequired,
      config: PropTypes.shape({
        buttons: PropTypes.array,
        actions: PropTypes.object,
        tooltip: PropTypes.array
      }),
      search: PropTypes.object,
      placeholder: PropTypes.string
    })
  }

  constructor(props) {
    super(props);
    this.state = {
      showBack: false,
      backLoaded: props.overlay
    } as WidgetState;
  }

  /*
  getWidgetSearch = (widget) => {
    return this.props.search || widget.getSearch();
  }
  */

  getContent = (widget) => {
    const { actions, placeholder } = this.props;
    // TODO find better way to distinguish between simple chart and chart wrapped in widget
    const content = widget.getContent ? widget.getContent() : widget;
    const isValid = widget.isValid ? widget.isValid() : true;
    /*
    const widgetSearch = this.getWidgetSearch(widget);
    switch (widget.getType()) {
      case WIDGET_TYPE.TEXTBOX:
        return (
          <AutosaveText
            className='widget-text-box'
            data={content.getText()}
            onSave={(value) => actions.updateTextBox(widget, value)}
            timeToSave={1000}
            id={content.getId()}/>
        );
      case WIDGET_TYPE.CHART:
      default:
        return (
          <ChartGenerator
            chart={content}
            actions={actions}
            isValid={isValid} // TODO return placeholder when not valid
            search={widgetSearch}
            placeholder={placeholder}/>
        );
      case WIDGET_TYPE.TABLE:
        return (
          <DataTable
            table={content}
            actions={actions}
            search={widgetSearch}
            placeholder={placeholder}/>
        );
    }*/
  }
  /*
  getIssues = (widget) => {
    const issues = widget.getIssues();
    if (issues.length > 0) {
      return (
        <div className='widget-issues'>
          <ul className='list'>
            {issues.map((issue, i) => <li key={i}>{issue}</li>)}
          </ul>
          <div className='icon'>
            <AlertIcon/>
          </div>
        </div>
      );
    }
    return null;
  }
  */
  /*
   getButtons = () => {
     const { frontContent, backContent, config } = this.props;
     const buttons = config.buttons || [];
 
     const hiddenContent = this.state.showBack ? frontContent : backContent;
     const shownContent = this.state.showBack ? backContent : frontContent;
     const type = hiddenContent ? hiddenContent.getType() : undefined;
     const flipButton = type ? ({
       id: `Action_Button_${getFlipperTitle(type)}_${frontContent.getId()}`,
       label: getFlipperTitle(type),
       icon: getFlipperIcon(type),
       action: () => this.setState({
         showBack: !this.state.showBack,
         backLoaded: true
       })
     }) : [];
 
     return buttons
       .filter(({ hidden }) => !(typeof hidden === 'function' ? hidden(shownContent) : hidden))
       .concat(flipButton)
       .map(({ id, icon, label, action }, key) => (
         <ActionButton
           id={id}
           key={key}
           icon={typeof icon === 'function' ? icon(shownContent) : icon}
           title={typeof label === 'function' ? label(shownContent) : label}
           onClick={() => action(shownContent)}
           small/>
       ));
   }
   */
  
  render() {
    /*
    const { frontContent, backContent, overlay, config, hideTitle } = this.props;
    const { showBack, backLoaded } = this.state;

    const flipperClasses = classNames('flipper', {
      flipped: !overlay && showBack
    });
    const frontContentClasses = classNames('front-content', {
      overlay
    });
    const backContentClasses = classNames('back-content', {
      overlay,
      switch: showBack
    });
    const widgetSearch = this.getWidgetSearch(frontContent);
    const searchId = widgetSearch ? widgetSearch.id : undefined;
    return (
      <div className='widget'>
        <header>
          {hideTitle ? null :
            <EditableInput
              value={frontContent.getName()}
              disabled={!frontContent.isBeingRenamed()}
              onSave={(name) => config.actions.rename(frontContent, name, searchId)} />}
          <div className='widget-buttons'>
            {this.getButtons()}
            <Tooltip
              widget={frontContent}
              options={config.tooltip}
            />
          </div>
        </header>
        <div className='flip-container'>
          <div className={flipperClasses}>
            <div className={frontContentClasses}>
              {this.getContent(frontContent)}
              {this.getIssues(frontContent)}
            </div>
            <div className={backContentClasses}>
              {backLoaded && this.getContent(backContent)}
              {backLoaded && this.getIssues(backContent)}
            </div>
          </div>
        </div>
      </div>
    );*/
    return (
      <React.Fragment>
      </React.Fragment>
    )
  }

}

export default Widget;
