import { useState, FunctionComponent, SetStateAction, Dispatch } from 'react'
import { Widget } from '../../types'

export interface WidgetActions {
  maximize: () => void
  restore: () => void
}

export interface WidgetProps extends Widget {
  actions: any
  placeholder: any
  overlay: any
  visuals: {
    [key: string]: FunctionComponent
  }
}

export interface WidgetState extends Omit<Widget, 'primary' | 'secondary'> {
  primary: FunctionComponent
  secondary: FunctionComponent
  beingRenamed?: boolean
  invalid?: boolean
  showBack?: boolean // TODO rename as flipped
  backLoaded?: any
}

export type WidgetEffect = [WidgetState | undefined, Dispatch<SetStateAction<WidgetState | undefined>>, WidgetActions]

export default ({ actions, placeholder, primary, secondary, visuals, ...widget }: WidgetProps): WidgetEffect => {
  const children = {
    primary: visuals[primary],
    secondary: secondary && visuals[secondary]
  }
  const [state, setState] =  useState<WidgetState>({ ...widget, ...children })

  const maximize = () => {
  }

  const restore = () => {}

  return [state, setState, {
    maximize,
    restore
  }]
}