export function generateUUID() {
  let d = Date.now();
  if (window.performance && typeof window.performance.now === 'function') {
    d += performance.now(); // use high-precision timer if available
  }
  const uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, (c) => {
    const r = (d + (Math.random() * 16)) % 16 | 0;
    d = Math.floor(d / 16);
    return (c === 'x' ? r : (r & (0x3 | 0x8))).toString(16);
  });
  return uuid;
}

export function generateID(prefix, title = '') {
  const suffix = title.toString().split(' ').join('');
  return `${prefix}_${suffix}`;
}

export { default as createPromiseResolver } from './createPromiseResolver'
export { default as useFetch } from './useFetch'