// import { browserHistory } from '@hpe/hercules-components'
import { TimeRange } from '../time/types'
import { fixedToCustom } from '../time/utils'
import { SyntacticTree } from 'orb-query//lib/syntax'
// import {  Search} from './types/Search'

export class SearchRunner {
  actions: any
  search: any

  constructor(actions, search, searches) {
    this.search = { ...search }
    this.actions = actions

    const syntacticTree = new SyntacticTree(search, searches || {}, null, null, null, null, null)
    syntacticTree.parseQuery(search.input)
    const { msSince, msUntil } = fixedToCustom(search.period)
    const moSql = syntacticTree.toMoSQL(msSince, msUntil)
    this.search.queryObject = moSql.asQueryObject()

    // this.unsubscribe = browserHistory.listen(this.handleUrl)
  }

  initiate() {
    // browserHistory.push('/search/new')
  }

  handleUrl = () => {
    const { pathname } = window.location
    if (!pathname.includes('/new')) {
      const { actions, search } = this

      const id = pathname.split('/').pop()
      search.id = id

      if (search.callback) {
        const parts = search.callback.split('/')
        parts[parts.length - 1] = id
        search.callback = parts.join('/')
      }

      actions.saveOrUpdateSearch(search)
      actions.execute(search)
      actions.setActiveSearch(search)
      actions.saveOrUpdateSearch(search)

      // this.unsubscribe()
    }
  }
}
