import { Search, SearchMap } from './types'
import { DatePicker } from '../time/datePicker'
import { SyntacticTree } from 'orb-query/lib/syntax/SyntacticTree'

const computeQuery = (search: Search, searches: SearchMap) => {
  const tree = new SyntacticTree(search, searches || {}, null, null, null, null, null)
  tree.parseQuery(search.query)
  const period = new DatePicker(search.period)
  const moSql = tree.toMoSQL(period.getStartDate(), period.getEndDate())
  const queryObject = moSql.asQueryObject()

  return queryObject
}

export default computeQuery