export const SAVE_OR_UPDATE = 'SAVE_OR_UPDATE_SEARCH'
export const EXECUTE = 'EXECUTE'
export const SET_ACTIVE = 'SET_ACTIVE'

export type SearchAction =
  Execute |
  SaveOrUpdate |
  SetActive

export type Execute = {
  type: typeof EXECUTE
}

export type SaveOrUpdate = {
  type: typeof SAVE_OR_UPDATE
}

export type SetActive = {
  type: typeof SET_ACTIVE
}

const mixin = (dispatch: (value: SearchAction) => void) => ({
  execute: () => dispatch({
    type: EXECUTE
  }),
  saveOrUpdate: () => dispatch({
    type: SAVE_OR_UPDATE
  }),
  setActive: () => dispatch({
    type: SET_ACTIVE
  })
})
export default mixin