export const LAST_1_MINUTE = 'LAST_1_MINUTE'
export const LAST_5_MINUTES = 'LAST_5_MINUTES'
export const LAST_15_MINUTES = 'LAST_15_MINUTES'
export const LAST_30_MINUTES = 'LAST_30_MINUTES'
export const LAST_60_MINUTES = 'LAST_60_MINUTES'
export const LAST_6_HOURS = 'LAST_6_HOURS'
export const LAST_12_HOURS = 'LAST_12_HOURS'
export const LAST_24_HOURS = 'LAST_24_HOURS'
export const LAST_7_DAYS = 'LAST_7_DAYS'
export const LAST_14_DAYS = 'LAST_14_DAYS'
export const TODAY = 'TODAY'
export const YESTERDAY = 'YESTERDAY'
export const WEEK_TO_DATE = 'WEEK_TO_DATE'
export const PREVIOUS_WEEK = 'PREVIOUS_WEEK'
export const MONTH_TO_DATE = 'MONTH_TO_DATE'
export const PREVIOUS_MONTH = 'PREVIOUS_MONTH'
export const YEAR_TO_DATE = 'YEAR_TO_DATE'
export const ALL_TIME = 'ALL_TIME'

export const FIXED_RANGES = [
  LAST_1_MINUTE,
  LAST_5_MINUTES,
  LAST_15_MINUTES,
  LAST_30_MINUTES,
  LAST_60_MINUTES,
  LAST_6_HOURS,
  LAST_12_HOURS,
  LAST_24_HOURS,
  LAST_7_DAYS,
  LAST_14_DAYS,
  TODAY,
  YESTERDAY,
  WEEK_TO_DATE,
  PREVIOUS_WEEK,
  MONTH_TO_DATE,
  PREVIOUS_MONTH,
  YEAR_TO_DATE,
  ALL_TIME
]

export const CUSTOM_RANGE = 'CUSTOM_RANGE'

export const TIME_FORMAT = 'YYYY-MM-DD HH:mm:ss'
export const TIME_FORMAT_EXACT = 'YYYY-MM-DD HH:mm:ss.SSS';

export const SECOND_IN_MILLISECONDS = 1000
export const MINUTE_IN_MILLISECONDS = 60 * SECOND_IN_MILLISECONDS
export const HOUR_IN_MILLISECONDS = 60 * MINUTE_IN_MILLISECONDS
export const DAY_IN_MILLISECONDS = 24 * HOUR_IN_MILLISECONDS
export const WEEK_IN_MILLISECONDS = 7 * DAY_IN_MILLISECONDS
export const MONTH_IN_MILLISECONDS = 30 * DAY_IN_MILLISECONDS

// TODO: quick ranges should not be declared with extra millisecond
export const FIXED_DURATION_IN_MILLISECONDS = {
  [LAST_1_MINUTE]: MINUTE_IN_MILLISECONDS,
  [LAST_5_MINUTES]: 5 * MINUTE_IN_MILLISECONDS,
  [LAST_15_MINUTES]: 15 * MINUTE_IN_MILLISECONDS,
  [LAST_30_MINUTES]: 30 * MINUTE_IN_MILLISECONDS,
  [LAST_60_MINUTES]: HOUR_IN_MILLISECONDS,
  [LAST_6_HOURS]: 6 * HOUR_IN_MILLISECONDS,
  [LAST_12_HOURS]: 12 * HOUR_IN_MILLISECONDS,
  [LAST_24_HOURS]: DAY_IN_MILLISECONDS,
  [LAST_7_DAYS]: 7 * DAY_IN_MILLISECONDS,
  [LAST_14_DAYS]: 14 * DAY_IN_MILLISECONDS,
  [TODAY]: DAY_IN_MILLISECONDS,
  [YESTERDAY]: DAY_IN_MILLISECONDS
}