import { Range, createRange } from '../../../../client/js/state/range';
import { runMethodTests } from './stateTestUtils';
import { timeHelper } from '../testUtils';

// all test names
const SANITY_CHECK = 'sanity check';

describe('Range redux state wrapper', () =>
  [{
    $name: SANITY_CHECK,
    $in: {
      start: 0,
      end: 1,
      startDate: timeHelper('2017-06-01 12:00:00'),
      endDate: timeHelper('2017-06-01 18:00:00')
    },
    $out: {
      getStartDate: timeHelper('2017-06-01 12:00:00'),
      getEndDate: timeHelper('2017-06-01 18:00:00'),
      asDatePicker: {
        startDate: timeHelper('2017-06-01 12:00:00'),
        endDate: timeHelper('2017-06-01 18:00:00'),
        datePickerLabel: 'Custom Range'
      }
    }
  }].forEach(testCase => {
    const range = new Range(testCase.$in);
    it(`Should create range equal to its serialized form for ${testCase.$name}`, () => {
      const { startDate, endDate, start, end } = testCase.$in;
      expect(range.serialize())
        .toEqual(createRange(start, end, startDate, endDate).serialize());
    });
    runMethodTests(testCase, range);
  })
);
