import * as moment from 'moment'

import {
  LAST_1_MINUTE,
  LAST_5_MINUTES,
  LAST_15_MINUTES,
  LAST_30_MINUTES,
  LAST_60_MINUTES,
  LAST_6_HOURS,
  LAST_12_HOURS,
  LAST_24_HOURS,
  LAST_7_DAYS,
  LAST_14_DAYS,
  TODAY,
  YESTERDAY,
  WEEK_TO_DATE,
  PREVIOUS_WEEK,
  MONTH_TO_DATE,
  PREVIOUS_MONTH,
  YEAR_TO_DATE,
  ALL_TIME,
  CUSTOM_RANGE
} from '../constants/time'

export type TimeRange = {
  fixed: FixedRange
} & {
  fixed: false | undefined
  msSince: number
  msUntil: number
}

export type FixedRange =
  typeof LAST_1_MINUTE |
  typeof LAST_5_MINUTES |
  typeof LAST_15_MINUTES |
  typeof LAST_30_MINUTES |
  typeof LAST_60_MINUTES |
  typeof LAST_6_HOURS |
  typeof LAST_12_HOURS |
  typeof LAST_24_HOURS |
  typeof LAST_7_DAYS |
  typeof LAST_14_DAYS |
  typeof TODAY |
  typeof YESTERDAY |
  typeof WEEK_TO_DATE |
  typeof PREVIOUS_WEEK |
  typeof MONTH_TO_DATE |
  typeof PREVIOUS_MONTH |
  typeof YEAR_TO_DATE |
  typeof ALL_TIME

export type Range = FixedRange | typeof CUSTOM_RANGE

export interface TimeScale {
  granularity: number
  groupBy: moment.unitOfTime.Diff
}

export interface Timeline<T> extends TimeScale {
  range: TimeRange
  collapsed: boolean
  data: T
}