import { runMethodTests } from './stateTestUtils';
import { createTrendLine, TrendLine } from '../../../../client/js/state/trendline';
import { Value } from '../../../../client/js/state/value';

const EMPTY = 'empty';
const NUMERIC = 'numeric';

describe('Value option redux state wrapper', () =>
  [{
    $name: EMPTY,
    $in: {},
    $out: {
      getRawValue: undefined
    }
  }, {
    $name: NUMERIC,
    $in: {
      value: { value: 1, special: false, label: 1 },
      setValue: [new Value({ value: 2 })]
    },
    $out: {
      getValue: { value: 1, label: 1, special: false },
      getRawValue: 1,
      setValue: {
        value: { value: 2, label: 2, special: false }
      }
    }
  }].forEach((testCase) => {
    const { value } = testCase.$in;
    const trendline = new TrendLine(testCase.$in);
    it(`Should create trendline equal to its serialized form for ${testCase.$name}`, () => {
      expect(trendline.serialize())
        .toEqual(createTrendLine(value ? new Value(value) : undefined).serialize());
    });
    runMethodTests(testCase, trendline);
  })
);
